#!/usr/bin/perl

use strict;
use lib qw{/opt/butter/lib};
use LARRD::config qw( @DATALIST );
use LARRD::checks qw( %larrdchecks );
use LARRD::html qw( larrdhtml );

##################################
# Start of script
##################################

if (&main()) {
  exit(0);
} else {
  exit(1);
}

#---
# C-style main
#---

sub main {
  close(STDERR);
  close(STDOUT);
  close(STDIN);
  open(STDOUT,">> $ENV{'LARRDLOG'}");
  open(STDERR,">> $ENV{'LARRDLOG'}");
  unless (&{$larrdchecks{'env'}}) {
    print(localtime().": ".(caller(0))[3].": ERROR Failed environment check.\n");
    return;
  }

  foreach my $mod (@DATALIST) {
    unless ((exists($larrdchecks{$mod})) && (defined($larrdchecks{$mod})) && ($larrdchecks{$mod} ne '') && (ref($larrdchecks{$mod}) eq 'CODE')) {
      print(localtime().": ".(caller(0))[3].": WARN No test defined for '$mod'\n");
      next;
    }
    unless (&{$larrdchecks{$mod}}) {
      print(localtime().": ".(caller(0))[3].": ERROR failed check '$mod'\n");
    }
  }

  # Generate HTML
  unless (&larrdhtml()) {
    print(localtime().": ".(caller(0))[3].": ERROR Failed to generate HTML.\n");
    return;
  }

  return 1;
}

