#!/usr/local/bin/perl

use strict;
use FindBin qw($Bin);
use lib "$Bin/..";
use LARRD::graphinfo qw( %graph_dsources %graph_titles );

&main();
exit(1);

sub main {
  while (my($service,$ds_ref) = each(%graph_dsources)) {
    while (my($ds,$count) = each(%$ds_ref)) {
      print("$service $ds $count\n");
    }
  }
}


sub sortu {

  my $sub_ref;

  if (ref($_[0]) eq 'CODE') {
    $sub_ref = shift;
  } else {
    $sub_ref = sub { $_[0] cmp $_[1] };
  }
  my @data = @_;

  # Bubble sort
  for (my $n = 0; $n < $#data; $n++) {
    my $cmpval = &{$sub_ref}($data[$n],$data[$n+1]);
    if ($cmpval == 0) {
      splice(@data,$n--,1);
    } elsif ($cmpval > 1) {
      ($data[$n],$data[$n+1]) = ($data[$n+1],$data[$n]);
      $n -= 2;
    }
  }
}

